#include "Grid.h"

#ifndef NULL  // I don't include anything that defines it here
#define NULL 0
#endif

Grid *Grid::onlyGrid(NULL);

Grid& Grid::instance() {
	if(onlyGrid == NULL)
		onlyGrid = new Grid();
	
	return *onlyGrid;
}

void Grid::resetGrid() {
	delete onlyGrid;
	onlyGrid = NULL;
}



bool Grid::move(int x_increment, int y_increment) {

	++num_actions;

	if(obstacle(pos_x + x_increment, pos_y + y_increment))
		return false;

	pos_x+= x_increment;
	pos_y+= y_increment;

	return true;
}

bool Grid::obstacle(int x, int y) const {
	return x<0 || y<0 || x > 3 || y > 2 || (x == 1 && y == 1);
}

double Grid::finalReward() const {
	if(pos_x == 3 && pos_y ==2)
		return 1;
	if(pos_x == 3 && pos_y == 1)
		return -1;
	
	return 0;
}

bool Grid::isFinal() const {
	return (pos_x == 3 && pos_y ==2) || (pos_x == 3 && pos_y == 1);
}
