#include "GridInstantiator.h"

#include <pnp/pnp_action.h>
#include <pnp/pnp_plan.h>
#include <pnp/basic_plan/basic_plan.h>

#include "MoveAction.h"

using namespace std;
using namespace PetriNetPlans;

GridInstantiator::GridInstantiator(const string& planDir, bool stochastic): 
		planDir(planDir),
		planLoader(),
		cond(),
		stochastic(stochastic){}



PetriNetPlans::PnpExecutable* GridInstantiator::createExecutable(const std::string& name) throw(std::runtime_error) {

	
	PnpExecutable *executable = createAction(name);
	if(executable != NULL)
		return executable;
	

	//otherwise, check if it is a plan
    PnpPlan *plan = new PnpPlan(this, &cond,name);
    string pnml = planDir + name + ".pnml";
    try {
        planLoader.loadFromPNML ( pnml, plan );

    } catch ( const std::runtime_error& ) {
		
		//no file for that plan
        string errorString ( "No action nor plan with name: " );
        errorString+=name;
        throw std::runtime_error ( errorString );
    }

    return plan;

}

PetriNetPlans::PnpExecutable* GridInstantiator::createAction(const std::string& name) {
	if (name == "ActMove_N")
		return new MoveAction(0,1,stochastic);
	if (name == "ActMove_W")
		return new MoveAction(-1,0,stochastic);
	if (name == "ActMove_S")
		return new MoveAction(0,-1,stochastic);
	if (name == "ActMove_E")
		return new MoveAction(1,0,stochastic);

	return NULL;
}

