#include "MoveAction.h"

#include "Grid.h"

#include <stdlib.h>

MoveAction::MoveAction(int x_increment, int y_increment,bool stochastic) : 
					x_incr(x_increment), 
					y_incr(y_increment),
					stochastic(stochastic){}

void MoveAction::executeStep() {
    

    int x_correction = 0;
    int y_correction = 0;

    if(stochastic) {
        int v = rand();
        if(v >= 0.8 * RAND_MAX) {
            int correction = (v < 0.9 * RAND_MAX)? +1:-1;
            if( x_incr == 0) {
                x_correction = correction;
                y_incr = 0;
            }
            else {
                y_correction = correction;
                x_incr = 0;
            }
        }
    }

	Grid::instance().move(x_incr+x_correction,y_incr+y_correction);
}

