

#include <pnp/pnp_executer.h>
#include <pnp/basic_plan/basic_plan.h>

#include "GridInstantiator.h"

#include <iostream>
#include <ctime>
#include <cmath>

#include "Grid.h"
#include "GridInstantiator.h"

#include <valarray>

using namespace PetriNetPlans;
using namespace std;

int main() {

	srand(time(0));
	
	const bool stochastic = false; 		//default: false
	const string mainPlanName = "grid";	//default: grid
	const string planDirName = "plans/";	//default plans/
	
	int seriesNum = stochastic? 1000: 1;
	int totalExperiments = stochastic? 50 : 1;
	int maxSteps = 30;
	

	PnpExecuter<PnpPlan> executor ( new GridInstantiator(planDirName,stochastic) );



    valarray<double> samples(seriesNum);

    for (int s=0; s<seriesNum; ++s) {

        double acc = 0;

        for ( int i=0; i<totalExperiments; ++i ) {

            executor.setMainPlan ( mainPlanName );

            while(!executor.goalReached() && Grid::instance().numActions() < maxSteps && !Grid::instance().isFinal()) {
                executor.execMainPlanStep();
            }

            acc += Grid::instance().finalReward() -
                     (Grid::instance().numActions() / static_cast<double>(maxSteps));

            Grid::resetGrid();
        }

        samples[s] = acc/totalExperiments; //sample mean
    }

    double sampleMean = samples.sum() / seriesNum;

    valarray<double> temp = samples - sampleMean;
    temp *= temp; //squared
    double stdOfTheMean = sqrt(temp.sum() / (seriesNum* seriesNum));

    cout << "Your result is: " << sampleMean << " +-" << 1.96 * stdOfTheMean << endl;

    return 0;

}
